# -*- coding: UTF-8 -*-
""" capellaScript -- Copyright (c) 2020 Peter Becker
>>> Ziach_D: Tabulaturschrift für Steirische Harmonika
    Vorbereitung um Köpfe auszurichten ||

    Bei Problemen bitte eine Mail an |
    (In case of problems, please email ):|peter_becker@freenet.de
<<<

History:  20.12.23 - V1.0.0  PB Basisversion   
          22.12.23 - V1.0.1  PB Leerstimme nur erzeugen wenn nur eine Stimme in der Zeile ist

"""
#-------------------------------------------------------------------

import xml.dom, tempfile, math
from caplib.capDOM import ScoreChange
from xml.dom.minidom import NodeList, Node, Element

#-------------------------------------------------------------------
version = '1.0.0'
#-------------------------------------------------------------------

def changeDoc(score):
    # Hauptroutine
    
    global doc
    
    for system in score.getElementsByTagName('system'):
        #messageBox('System',str(system))
        for staff in system.getElementsByTagName('staff'):
            layout = staff.getAttribute('layout')
            #messageBox('layout',str(layout))
            if layout == 'Tabulatur':
                for voices in staff.getElementsByTagName('voices'):                       # Leerstimme nur erzeugen wenn nur eine Stimme in der Zeile
                    xxx = voices.getElementsByTagName('voice')
                if len(xxx) == 1:
                    for voice in staff.getElementsByTagName('voice'):
                        clone = voice.cloneNode(True)
                        voice.parentNode.insertBefore(clone, voice)
                        x = 0
                        for voice in staff.getElementsByTagName('voice'):
                            if x == 1:
                                for chord in voice.getElementsByTagName('chord'):  
                                    chord.parentNode.removeChild(chord)
                                for rest in voice.getElementsByTagName('rest'):  
                                    rest.parentNode.removeChild(rest) 
                                for barline in voice.getElementsByTagName('barline'):  
                                    barline.parentNode.removeChild(barline) 
                                for timeSign in voice.getElementsByTagName('timeSign'):  
                                    timeSign.parentNode.removeChild(timeSign)  
                            else:
                                x = 1 
                        
        for system in score.getElementsByTagName('system'):
            #messageBox('system',str(system))
            for staff in system.getElementsByTagName('staff'):
                layout = staff.getAttribute('layout')
                #messageBox('layout',str(layout))
                if layout == 'Tabulatur':
                    voices = staff.getElementsByTagName('voices')
                    #messageBox('vos',str(voices))
                    for chord in voices[0].getElementsByTagName('chord'):
                        #messageBox('chords',str(chord))  
                        dOs = chord.getElementsByTagName('drawObjects')
                        if dOs:
                            #messageBox('dOs',str(dOs))
                            display = doc.createElement('display')
                            display.setAttribute('noAutoXShift','true')
                            dOs[0].parentNode.insertBefore(display, dOs[0])
                        else:
                            heads = chord.getElementsByTagName('heads')
                            display = doc.createElement('display')
                            display.setAttribute('noAutoXShift','true')
                            heads[0].parentNode.insertBefore(display, heads[0])                            
                       
# Hauptprogramm:

from xml.dom.minidom import NodeList, Node, Element
from caplib.rational import Rational
from caplib.capDOM import ScoreChange
import tempfile, string, new

class ScoreChange(ScoreChange):
    def changeScore(self, score):
        global doc
        doc = score.parentNode
        changeDoc(score)


if activeScore():
    
    activeScore().registerUndo('Ziach_D')
    tempInput = tempfile.mktemp('.capx')
    tempOutput = tempfile.mktemp('.capx')
    activeScore().write(tempInput)
    
    ScoreChange(tempInput, tempOutput)

    activeScore().read(tempOutput)
    os.remove(tempInput)
    os.remove(tempOutput)